=== debian/changelog ===
siconos (4.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version. (Closes: #962219) (Closes: #961735)
  * Add dependencies libboost-timer-dev, libboost-chrono-dev.
  * Depend on openblas and lapacke instead of atlas.
  * Require fclib 3.1.0
  * Update location of install paths.
  * Enable WITH_GENERATION, now required for serialization.
  * Install new siconos_export_raw_data tool.
  * Fix cmake import targets to allow independent packages.
  * Update patches for new upstream version.
  * Add a flag for gfortran to avoid a regression in GCC-10.
    (Closes: #957794)
  * Remove unused build rule for swig3.0 symlink.
  * Remove non-existent files from debian/copyright.
  * Rewrite patch descriptions using gbp pq.
  * Fix a Python warning about using 'is' with a literal.
  * Patch for setup.py to import Command from distutils.core.
  * Patch to fix broken lapacke linkage.
  * Remove empty override_dh_auto_clean.
  * Patch to update use of node factory in breathe.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 07 Sep 2020 18:59:58 +0000

siconos (4.2.0+git20181026.0ee5349+dfsg.2-3) unstable; urgency=medium

  * Patch to remove bad cc options.
  * Patch to find python3.8 config.
  * Depend on swig instead of swig3.0.
  * Backport support for swig4.0. (Closes: #952601)
  * Removed a failing numerics test.
  * debian/rules: Remove use of ccache. (Closes: #945613 #954497)
  * Require Python 3.8.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 23 Mar 2020 21:11:30 +0000
